/*****************************************************************************************
/* File: IO.h
/* Desc: Class for handling inpung & drawing, it uses SDL for the rendering. Change the methods of this class
/*       in order to use a different renderer
/*
/* gametuto.com - Javier Lpez Lpez (javilop.com)
/*
/*****************************************************************************************
/*
/* Creative Commons - Attribution 3.0 Unported
/* You are free:
/*	to Share  to copy, distribute and transmit the work
/*	to Remix  to adapt the work
/*
/* Under the following conditions:
/* Attribution. You must attribute the work in the manner specified by the author or licensor
/* (but not in any way that suggests that they endorse you or your use of the work).
/*
/*****************************************************************************************/

#ifndef _IO_
#define _IO_

// ------ Includes -----

/*#ifndef LINUX
#include "SDL/include/SDL.h"
#include "SDL/SDL_GfxPrimitives/SDL_gfxPrimitives.h"
#else*/
#include <SDL/SDL.h>
#include "SDL/sdl_gfxprimitives.h"
/*#endif
#pragma comment (lib, "SDL/lib/SDL.lib")
#pragma comment (lib, "SDL/SDL_GfxPrimitives/SDL_GfxPrimitives_Static.lib")*/

// ------ Enums -----

enum color {BLACK, RED, GREEN, BLUE, CYAN, MAGENTA, YELLOW, WHITE, COLOR_MAX}; // Colors

/* Caanoo button mapping */
enum CaanooButtons {
        CAANOO_BUTTON_A = 0,
        CAANOO_BUTTON_X = 1,
        CAANOO_BUTTON_B = 2,
        CAANOO_BUTTON_Y = 3,
        CAANOO_BUTTON_L = 4,
        CAANOO_BUTTON_R = 5,
        CAANOO_BUTTON_HOME = 6,
        CAANOO_BUTTON_1 = 8,
        CAANOO_BUTTON_2 = 9,
        CAANOO_BUTTON_JOY = 10,
        CAANOO_AXIS_LEFT = 11,
        CAANOO_AXIS_RIGHT = 12,
        CAANOO_AXIS_UP  =13,
        CAANOO_AXIS_DOWN = 14
};

// --------------------------------------------------------------------------------
//									 IO
// --------------------------------------------------------------------------------

class IO
{
public:

	IO						();
	virtual ~IO             ();

	void DrawRectangle		(int pX1, int pY1, int pX2, int pY2, enum color pC);
	void ClearScreen		();
	int GetScreenHeight		();
	int InitGraph			();
	int Pollkey				();
	int Getkey				();
	int IsKeyDown			(int pKey);
	int IsButtonDown        (int pBut);
	void UpdateScreen		();

private:
    SDL_Joystick *m_joy;
};

#endif // _IO_
